//  Misja w nadprzestrzeń C++14/17, program z paragrafu 1.01

#include <iostream>
#include <string>
using namespace std;
 //*******************************************************
template <typename...   Tpakiet>											// `1
void szabfun(Tpakiet... args)												// `2
{
	cout << "   Funkcja szablonowa  szabfun\n	"
		<< __PRETTY_FUNCTION__										// `3
		<< "\n   odebrala paczke "
		<< (sizeof...( Tpakiet))												// `4
		<< " argumentow  " 	<< endl;
	// ewentualne dalsze czynności...
}
//******************************************************
template <typename T, typename...   Tpakiet>									// `5
void wydrukuj(T pierwszy, Tpakiet... reszta)									// `6
{
	cout	<< "   Funkcja szablonowa \n   " << __PRETTY_FUNCTION__
		<< "\n   odebrala (1 argument + paczke "
		<< (sizeof...( Tpakiet))												// `7
		<< " argumentow)" << endl;

	cout << "   Wydruk pierwszego argumentu: " << pierwszy << endl; 				// `8
	// ... dalsze czynności
}
//******************************************************
int main()
{
	cout << "Wywolanie f. szablonowej z parametrami (w ostrych nawiasach)\n";
	szabfun<int, char, double>(100, '$', 3.14);									// `9
	cout << "Funkcje szablonowa mozna wywolac bez ostrych nawiasow\n";
	szabfun(100, '$', 3.14);												 	// `10
	szabfun("alert", 12, 3.33, '#', 100, "silniki jonowe", 3, "przegrzanie", string("ASDFG") ); 		// `11

	cout << "=========================== Praca z inna f. szablonowa \n";
	cout << "Gdy wysylamy 3 argumenty\n";
	wydrukuj(100, '$', 3.14);													 // `12
	cout << "Gdy wysylamy 1 argument\n";
	wydrukuj(100000000000L);   											// `13
	cout << "Gdy wysylamy 9 argumentow\n";
	wydrukuj("alert", 12, 3.33, '#', 100, "silniki jonowe", 3, "przegrzanie", string("ASDFG") ); 		// `14
}
