//  Misja w nadprzestrzeń C++14/17, program z paragrafu 1.3


#include <iostream>
#include <string>
using namespace std;
/////////////////////////////////////////////////////////////////////////////////////////
class Tkierowca															// `1
{
public:
	Tkierowca(char kat) 													// `2
	{
		cout << "\tJestem kierowca kategorii: " << kat << endl;
	}
};
/////////////////////////////////////////////////////////////////////////////////////////
class Ttenisista															// `3
{
public:
	int waga_rakiety;
	Ttenisista(int waga) : waga_rakiety(waga) 									 // `4
	{
		cout << "\tJestem tenisista, moja rakieta wazy uncji: " << waga << endl;
	}
};
/////////////////////////////////////////////////////////////////////////////////////////
class Tkrwiodawca 														// `5
{
public:
	string grupa_krwi;
	Tkrwiodawca(string txt):grupa_krwi(txt)									// `6
	{
		cout << "\tJestem krwiodawca, moja grupa krwi to: " << txt << endl;
	}
};
/////////////////////////////////////////////////////////////////////////////////////////
// O TYM SZABLONIE ROZMAWIAMY W TYM PARAGRAFIE
/////////////////////////////////////////////////////////////////////////////////////////

template <typename...   Tkl_podstawowe>										// `7
class Tstudent : public Tkl_podstawowe...										// `8
{
	string imie;
public:
	Tstudent (const char * im, Tkl_podstawowe... podst) :  						// `9
					 			Tkl_podstawowe(podst)...,  					// `10
								imie(im)									// `11
	{
		cout << "to ja, " << imie << ". (Mowil konstruktor klasy Tstudent) "
			<< "\n----------------------------------------------"  << endl;
	}
};
/////////////////////////////////////////////////////////////////////////////////////////
class Twieczny 															// `12
{
public:
	Twieczny()
	{
		cout << "\tJestem wiecznym studentem " << endl;
	}
};
/////////////////////////////////////////////////////////////////////////////////////////
template < >				// specjalizacja szablonu  							// `13
class Tstudent< >															// `14
{
public:
	string imie;

	Tstudent (const char * im) : imie(im)
	{
		cout << im << " to specjalizowany Kujon. (Nigdzie nie nalezy)"
			<< "\n------------------------------"  << endl;
	}
	//...
};
/////////////////////////////////////////////////////////////////////////////////////////
template < >				// inna specjalizacja szablonu  						// `15
class Tstudent<Twieczny> : public Twieczny  									// `16
{
public:
	string imie;
	Tstudent (const char * im): 	Twieczny(),  imie(im)
	{
		cout << im << ", specjalizowany wieczny student."
			<< "\n------------------------------"  << endl;
	}
	//...
};
//******************************************************
void stacja_benzynowa(Tkierowca *k)											// `17
{
	cout << "  Obsluga kierowcy, pal szesc, jakiej kategorii..." << endl;
}
//******************************************************
void punkt_pobran(Tkrwiodawca *k)  											// `18
{
	cout << "  Pobieranie krwi o grupie: " << k->grupa_krwi << endl;
}
//******************************************************
void kort(Ttenisista *t)  														// `19
{
	cout << "  Tenisista gra na korcie rakieta o wadze " << t->waga_rakiety << " uncji " << endl;
}
//******************************************************
int main()
{
	cout << "Pamietaj, ze najpierw odzywaja sie konstruktory klas podstawowych\n-----\n";
	Tstudent<Ttenisista>  waldek("Waldek", 14); 								// `20
	Tstudent<Tkierowca, Tkrwiodawca>  karol("Karol", 'B', string("0 Rh+") );  			// `21
	Tstudent<Tkrwiodawca, Tkierowca, Ttenisista>  zosia("Zosia", string("AB Rh+"), 'B', 12);  	// `22
	Tstudent< > dionizy("Dyzio");												// `23
	Tstudent <Twieczny>  balsamo("Jozef Balsamo");  							// `24

	cout << "\nPrzykladowe aktywnosci studentow:\n";
	stacja_benzynowa(&karol); 	//<$[symbol><@172> <$]symbol>to dowód, że karol jest kierowcą 			// `25
	punkt_pobran(&karol);  		//<--- to dowód, że karol jest (także) krwiodawcą  			// `26
	// kort(&karol);  			<--- to jest dowód, że karol NIE jest rodzajem tenisisty  		// `27

	kort(&zosia);															// `28
	kort(&waldek);
	punkt_pobran(&zosia);
}
